"""Typographic components."""

from .blockquote import Blockquote
from .code import Code
from .em import Em
from .heading import Heading
from .kbd import Kbd
from .link import Link
from .quote import Quote
from .strong import Strong
from .text import Text

blockquote = Blockquote.create
code = Code.create
em = Em.create
heading = Heading.create
kbd = Kbd.create
link = Link.create
quote = Quote.create
strong = Strong.create
text = Text.create

__all__ = [
    "blockquote",
    "code",
    "em",
    "heading",
    "kbd",
    "link",
    "quote",
    "strong",
    "text",
]
